#ifndef _CTDEFINES_H
#define _CTDEFINES_H

#ifndef WIN32
#include <unistd.h>
#include <sys/times.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

// Allgemeine Makros
#define CT_SYSTEM_TIME ((double)(time(NULL)))

// Betriebssystemabhaengige Makros
#ifdef WIN32
#define CT_POPEN _popen
#define CT_GNUPLOT_EXE "gnuplot.exe"
#define CT_PCLOSE(pipe) _pclose(pipe)
#define CT_SLEEP(seconds) Sleep(seconds*1000) 
#else
#define CT_POPEN popen
#define CT_GNUPLOT_EXE "gnuplot"
#define CT_PCLOSE(pipe) pclose(pipe)
#define CT_SLEEP(seconds) sleep(seconds) 
#endif

inline unsigned int 
ctSeed()
{
  int seed;
#ifdef WIN32
  seed = (unsigned int)clock();
#else
  struct timeval tv; 
  struct timezone tz;
  gettimeofday(&tv, &tz); 
  seed = tv.tv_usec;
#endif
  return seed;
}


#endif // _CTDEFINES_H


