// Turn-Schuh-Problem Individuum
// Neue Klasse, deren Objekte mit CPPvm uebertragen werden koennen

#ifndef _TSP_INDIVIDUUM_INCLUDE
#define _TSP_INDIVIDUUM_INCLUDE

// Basisklasse fuer all uebertragbaren Klassen
#include "pvm_obj.h"
// sqrt Funktion
#include <math.h>
// Datei-Funktionen
#include <stdio.h>
// Defines/Makros
#include "ctdefines.h"
#include "tspdefines.h"

class tspIndividuum : public cppvmObject{
  
public:
  ////////////////////////////////////////////////
  // Methoden, die fuer CPPvm benoetigt werden //
  //////////////////////////////////////////////
  
  // Konstructor/Destructor
  tspIndividuum();
  virtual ~tspIndividuum();
  
  // Datentransfer Methode
  virtual void cppvmTransfer();
  
  // CPPvm Makro mit eindeutiger Klassen-ID
  CPPvmMethodsDeclaration(111)
    
public:
  ///////////////////////
  // Weitere Methoden //
  /////////////////////
  
  // Zuweisung
  tspIndividuum& operator=(const tspIndividuum& obj);
  // Route mit Zufallswerten erzeugen
  void init(float wertebereichXMin=0.0, float wertebereichXMax=100.0,
            float wertebereichYMin=0.0, float wertebereichYMax=100.0);
  // Datei-Routinen
  bool liesRouteVonDatei(char *dateiname);
  bool schreibeRouteInDatei(char *dateiname);
  // Erzeugen einer modifizierten Route
  void mutation();
  // gib/setze Methoden der Daten
  float gibRoutenLaenge(){return routenLaenge;}
  int gibMutationStreckenLaenge(){
    return mutationStreckenLaenge;}
  void  setzeMutationStreckenLaenge(int wert){
    mutationStreckenLaenge=wert;}

protected:
  // Zufallswert erzeugen
  float zufallswert(float wertebereichMin, float wertebereichMax);
  // Berechnen einer Distanz
  float distanz(unsigned int index1, unsigned int index2);
  // Berechnen der Routenlaenge
  void routeBerechnen();
  
protected:
  // Daten
  float *xPositionen;
  float *yPositionen;
  int mutationStreckenLaenge;
  float routenLaenge;
};

// Vergleichsfunktion fuer zwei Individuen
// fuer die Sortierung einer cppvmObjectCollection Liste
bool tspIndividuumVergleich(cppvmObject* obj1, cppvmObject* obj2);

#endif

