// CPPvm bekannt machen
#include "cppvm.h"
// Defines/Makros
#include "ctdefines.h"

int
main()
{
  // Datenobjekte
  cppvmString MuellersPost, MaiersPost, 
    SchmidtsPost, ZumwinkelsPost;
  int anzahlBroetchen=0;
  bool lieferung;

  // Den eigenen Prozess in die "Parallel 
  // Virtual Machine" (PVM) einklinken
  cppvmConnection pvmConn;

  // Starten des Prozesses "postbote".
  cppvmSpawnConnection child("postbote");

  // Empfangs-Kanal
  cppvmReceiveStream recStrm;

  // Frau Mueller steht unerschuetterlich vor 
  // dem Briefkasten und wartet auf die Post
  recStrm.set(child, CPPvmRBchild);
  recStrm >> MuellersPost;
  cout << "Postbote an Mueller: " << MuellersPost << endl;

  // Herr Maier wartet 0,2 Sekunden auf die Post, mu
  // dann vor lauter Aufregung auf die Toilette, 
  // wartet anschlieend wieder usw.
  // (zeitbeschraenktes Warten)
  recStrm.set(child, CPPvmRTchild, 0, 200000);
  lieferung = false;
  while(lieferung==false){
    recStrm >> MaiersPost;
    lieferung = recStrm.received();
    cout << "Maier: Nur mal schnell auf's Oertchen..." << endl;
  }
  cout << "Postbote an Maier: " << MaiersPost << endl;

  // Herr Schmidt bekommt auf dem Weg zur Post Hunger, 
  // schaut nur kurz ob etwas angekommen ist und holt sich
  // gleich wieder ein Broetchen
  // (nicht-blockierendes Warten)
  recStrm.set(child, CPPvmRNBchild);
  lieferung = false;
  while(lieferung==false){
    recStrm >> SchmidtsPost;
    lieferung = recStrm.received();
    anzahlBroetchen++;
  }
  cout << "Schmidt: Wegen der c't musste ich " << anzahlBroetchen
       << " Broetchen futtern!" << endl;
  cout << "Postbote an Schmidt: " << SchmidtsPost << endl;

  // Den Brieftraeger ein bischen zappeln lassen
  CT_SLEEP(1);

  // Herr Zumwinkel wartet ebenfalls am Briefkasten
  // auf den Brieftraeger, bekommt die Post
  // allerdings persoenlich ueberreicht
  recStrm.set(child, CPPvmRBchild);
  recStrm >> ZumwinkelsPost;
  cout << "Postbote an Zumwinkel: " << ZumwinkelsPost << endl;

  // Beenden aller Prozesse
  pvmConn.halt();

  return 0;
}
