// CPPvm bekannt machen
#include "cppvm.h"
// Route
#include "tspIndividuum.h"
// Defines/Makros
#include "ctdefines.h"
#include "tspdefines.h"

void 
selektion(cppvmObjectCollection& population, 
          tspIndividuum& besteRoute)
{
  int i;
  // ersetzen der k schlechtesten Routen
  for(i=0; i<TSP_ANZAHL_ERSETZEN; i++){
    ((tspIndividuum&)population[i])=besteRoute;
  }
}


int
main()
{
  // Routenobjekt
  tspIndividuum besteRoute;
  
  // Den eigenen Prozess in die "Parallel 
  // Virtual Machine" (PVM) einklinken
  cppvmConnection pvmConn;
  // Nachrichtenkanle zu Elter-Proze:
  // Nicht-blockierendes senden
  cppvmSendStream sendStrm(pvmConn, CPPvmSNBparent);
  // Blockierendes Emfangen
  cppvmReceiveStream recStrm(pvmConn, CPPvmRBparent);

  // Liste mit Routen anlegen
  cppvmObjectCollection population;
  int i,j;
  for(i=0; i<TSP_POPULATIONSGROESSE; i++){
    population.add(new tspIndividuum());
  }
  
  // Empfangen einer Route vom Meister
  recStrm >> besteRoute;
  
  // Initialisierung der ganzen Population mit dieser Route
  for(i=0; i<TSP_POPULATIONSGROESSE; i++){
    ((tspIndividuum&)population[i])=besteRoute;
  }

  while(true){
    for(j=0; j<TSP_ANZAHL_ZYKLEN; j++){
      // Neue Routen berechnen
      for(i=0; i<TSP_POPULATIONSGROESSE; i++){
        ((tspIndividuum&)population[i]).mutation();
      }
      // Routen nach Routenlaenge sortieren
      population.sort(tspIndividuumVergleich);
      // Beste Route merken
      if(((tspIndividuum&)population[TSP_POPULATIONSGROESSE-1]).gibRoutenLaenge()<
         besteRoute.gibRoutenLaenge()){
        besteRoute=(tspIndividuum&)population[TSP_POPULATIONSGROESSE-1];
      }
      // Beste Route zur Selektion geben
      selektion(population, besteRoute);
    }
    
    // Senden der besten Route
    sendStrm << besteRoute;
    // Empfangen einer neuen besten Route 
    recStrm >> besteRoute;

    // Selektion mit erhaltener Route
    selektion(population, besteRoute);

    // und wieder von vorne
  }

  return 0;
}
